Merge branch 'jk/reflog-date' into next
[git] / git-am.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005, 2006 Junio C Hamano
4
5 SUBDIRECTORY_OK=Yes
6 OPTIONS_KEEPDASHDASH=
7 OPTIONS_SPEC="\
8 git am [options] [<mbox>|<Maildir>...]
9 git am [options] (--resolved | --skip | --abort)
10 --
11 i,interactive   run interactively
12 b,binary*       (historical option -- no-op)
13 3,3way          allow fall back on 3way merging if needed
14 q,quiet         be quiet
15 s,signoff       add a Signed-off-by line to the commit message
16 u,utf8          recode into utf8 (default)
17 k,keep          pass -k flag to git-mailinfo
18 c,scissors      strip everything before a scissors line
19 whitespace=     pass it through git-apply
20 ignore-space-change pass it through git-apply
21 ignore-whitespace pass it through git-apply
22 directory=      pass it through git-apply
23 C=              pass it through git-apply
24 p=              pass it through git-apply
25 patch-format=   format the patch(es) are in
26 reject          pass it through git-apply
27 resolvemsg=     override error message when patch failure occurs
28 r,resolved      to be used after a patch failure
29 skip            skip the current patch
30 abort           restore the original branch and abort the patching operation.
31 committer-date-is-author-date    lie about committer date
32 ignore-date     use current timestamp for author date
33 rebasing*       (internal use for git-rebase)"
34
35 . git-sh-setup
36 prefix=$(git rev-parse --show-prefix)
37 set_reflog_action am
38 require_work_tree
39 cd_to_toplevel
40
41 git var GIT_COMMITTER_IDENT >/dev/null ||
42         die "You need to set your committer info first"
43
44 if git rev-parse --verify -q HEAD >/dev/null
45 then
46         HAS_HEAD=yes
47 else
48         HAS_HEAD=
49 fi
50
51 sq () {
52         git rev-parse --sq-quote "$@"
53 }
54
55 stop_here () {
56     echo "$1" >"$dotest/next"
57     exit 1
58 }
59
60 stop_here_user_resolve () {
61     if [ -n "$resolvemsg" ]; then
62             printf '%s\n' "$resolvemsg"
63             stop_here $1
64     fi
65     cmdline="git am"
66     if test '' != "$interactive"
67     then
68         cmdline="$cmdline -i"
69     fi
70     if test '' != "$threeway"
71     then
72         cmdline="$cmdline -3"
73     fi
74     echo "When you have resolved this problem run \"$cmdline --resolved\"."
75     echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
76     echo "To restore the original branch and stop patching run \"$cmdline --abort\"."
77
78     stop_here $1
79 }
80
81 go_next () {
82         rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
83                 "$dotest/patch" "$dotest/info"
84         echo "$next" >"$dotest/next"
85         this=$next
86 }
87
88 cannot_fallback () {
89         echo "$1"
90         echo "Cannot fall back to three-way merge."
91         exit 1
92 }
93
94 fall_back_3way () {
95     O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
96
97     rm -fr "$dotest"/patch-merge-*
98     mkdir "$dotest/patch-merge-tmp-dir"
99
100     # First see if the patch records the index info that we can use.
101     git apply --build-fake-ancestor "$dotest/patch-merge-tmp-index" \
102         "$dotest/patch" &&
103     GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
104     git write-tree >"$dotest/patch-merge-base+" ||
105     cannot_fallback "Repository lacks necessary blobs to fall back on 3-way merge."
106
107     say Using index info to reconstruct a base tree...
108     if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
109         git apply --cached <"$dotest/patch"
110     then
111         mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
112         mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
113     else
114         cannot_fallback "Did you hand edit your patch?
115 It does not apply to blobs recorded in its index."
116     fi
117
118     test -f "$dotest/patch-merge-index" &&
119     his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
120     orig_tree=$(cat "$dotest/patch-merge-base") &&
121     rm -fr "$dotest"/patch-merge-* || exit 1
122
123     say Falling back to patching base and 3-way merge...
124
125     # This is not so wrong.  Depending on which base we picked,
126     # orig_tree may be wildly different from ours, but his_tree
127     # has the same set of wildly different changes in parts the
128     # patch did not touch, so recursive ends up canceling them,
129     # saying that we reverted all those changes.
130
131     eval GITHEAD_$his_tree='"$FIRSTLINE"'
132     export GITHEAD_$his_tree
133     if test -n "$GIT_QUIET"
134     then
135             export GIT_MERGE_VERBOSITY=0
136     fi
137     git-merge-recursive $orig_tree -- HEAD $his_tree || {
138             git rerere
139             echo Failed to merge in the changes.
140             exit 1
141     }
142     unset GITHEAD_$his_tree
143 }
144
145 clean_abort () {
146         test $# = 0 || echo >&2 "$@"
147         rm -fr "$dotest"
148         exit 1
149 }
150
151 patch_format=
152
153 check_patch_format () {
154         # early return if patch_format was set from the command line
155         if test -n "$patch_format"
156         then
157                 return 0
158         fi
159
160         # we default to mbox format if input is from stdin and for
161         # directories
162         if test $# = 0 || test "x$1" = "x-" || test -d "$1"
163         then
164                 patch_format=mbox
165                 return 0
166         fi
167
168         # otherwise, check the first few lines of the first patch to try
169         # to detect its format
170         {
171                 read l1
172                 read l2
173                 read l3
174                 case "$l1" in
175                 "From "* | "From: "*)
176                         patch_format=mbox
177                         ;;
178                 '# This series applies on GIT commit'*)
179                         patch_format=stgit-series
180                         ;;
181                 "# HG changeset patch")
182                         patch_format=hg
183                         ;;
184                 *)
185                         # if the second line is empty and the third is
186                         # a From, Author or Date entry, this is very
187                         # likely an StGIT patch
188                         case "$l2,$l3" in
189                         ,"From: "* | ,"Author: "* | ,"Date: "*)
190                                 patch_format=stgit
191                                 ;;
192                         *)
193                                 ;;
194                         esac
195                         ;;
196                 esac
197                 if test -z "$patch_format" &&
198                         test -n "$l1" &&
199                         test -n "$l2" &&
200                         test -n "$l3"
201                 then
202                         # This begins with three non-empty lines.  Is this a
203                         # piece of e-mail a-la RFC2822?  Grab all the headers,
204                         # discarding the indented remainder of folded lines,
205                         # and see if it looks like that they all begin with the
206                         # header field names...
207                         sed -n -e '/^$/q' -e '/^[       ]/d' -e p "$1" |
208                         LC_ALL=C egrep -v '^[!-9;-~]+:' >/dev/null ||
209                         patch_format=mbox
210                 fi
211         } < "$1" || clean_abort
212 }
213
214 split_patches () {
215         case "$patch_format" in
216         mbox)
217                 case "$rebasing" in
218                 '')
219                         keep_cr= ;;
220                 ?*)
221                         keep_cr=--keep-cr ;;
222                 esac
223                 git mailsplit -d"$prec" -o"$dotest" -b $keep_cr -- "$@" > "$dotest/last" ||
224                 clean_abort
225                 ;;
226         stgit-series)
227                 if test $# -ne 1
228                 then
229                         clean_abort "Only one StGIT patch series can be applied at once"
230                 fi
231                 series_dir=`dirname "$1"`
232                 series_file="$1"
233                 shift
234                 {
235                         set x
236                         while read filename
237                         do
238                                 set "$@" "$series_dir/$filename"
239                         done
240                         # remove the safety x
241                         shift
242                         # remove the arg coming from the first-line comment
243                         shift
244                 } < "$series_file" || clean_abort
245                 # set the patch format appropriately
246                 patch_format=stgit
247                 # now handle the actual StGIT patches
248                 split_patches "$@"
249                 ;;
250         stgit)
251                 this=0
252                 for stgit in "$@"
253                 do
254                         this=`expr "$this" + 1`
255                         msgnum=`printf "%0${prec}d" $this`
256                         # Perl version of StGIT parse_patch. The first nonemptyline
257                         # not starting with Author, From or Date is the
258                         # subject, and the body starts with the next nonempty
259                         # line not starting with Author, From or Date
260                         perl -ne 'BEGIN { $subject = 0 }
261                                 if ($subject > 1) { print ; }
262                                 elsif (/^\s+$/) { next ; }
263                                 elsif (/^Author:/) { print s/Author/From/ ; }
264                                 elsif (/^(From|Date)/) { print ; }
265                                 elsif ($subject) {
266                                         $subject = 2 ;
267                                         print "\n" ;
268                                         print ;
269                                 } else {
270                                         print "Subject: ", $_ ;
271                                         $subject = 1;
272                                 }
273                         ' < "$stgit" > "$dotest/$msgnum" || clean_abort
274                 done
275                 echo "$this" > "$dotest/last"
276                 this=
277                 msgnum=
278                 ;;
279         *)
280                 if test -n "$parse_patch" ; then
281                         clean_abort "Patch format $patch_format is not supported."
282                 else
283                         clean_abort "Patch format detection failed."
284                 fi
285                 ;;
286         esac
287 }
288
289 prec=4
290 dotest="$GIT_DIR/rebase-apply"
291 sign= utf8=t keep= skip= interactive= resolved= rebasing= abort=
292 resolvemsg= resume= scissors=
293 git_apply_opt=
294 committer_date_is_author_date=
295 ignore_date=
296
297 while test $# != 0
298 do
299         case "$1" in
300         -i|--interactive)
301                 interactive=t ;;
302         -b|--binary)
303                 : ;;
304         -3|--3way)
305                 threeway=t ;;
306         -s|--signoff)
307                 sign=t ;;
308         -u|--utf8)
309                 utf8=t ;; # this is now default
310         --no-utf8)
311                 utf8= ;;
312         -k|--keep)
313                 keep=t ;;
314         -c|--scissors)
315                 scissors=t ;;
316         --no-scissors)
317                 scissors=f ;;
318         -r|--resolved)
319                 resolved=t ;;
320         --skip)
321                 skip=t ;;
322         --abort)
323                 abort=t ;;
324         --rebasing)
325                 rebasing=t threeway=t keep=t scissors=f ;;
326         -d|--dotest)
327                 die "-d option is no longer supported.  Do not use."
328                 ;;
329         --resolvemsg)
330                 shift; resolvemsg=$1 ;;
331         --whitespace|--directory)
332                 git_apply_opt="$git_apply_opt $(sq "$1=$2")"; shift ;;
333         -C|-p)
334                 git_apply_opt="$git_apply_opt $(sq "$1$2")"; shift ;;
335         --patch-format)
336                 shift ; patch_format="$1" ;;
337         --reject|--ignore-whitespace|--ignore-space-change)
338                 git_apply_opt="$git_apply_opt $1" ;;
339         --committer-date-is-author-date)
340                 committer_date_is_author_date=t ;;
341         --ignore-date)
342                 ignore_date=t ;;
343         -q|--quiet)
344                 GIT_QUIET=t ;;
345         --)
346                 shift; break ;;
347         *)
348                 usage ;;
349         esac
350         shift
351 done
352
353 # If the dotest directory exists, but we have finished applying all the
354 # patches in them, clear it out.
355 if test -d "$dotest" &&
356    last=$(cat "$dotest/last") &&
357    next=$(cat "$dotest/next") &&
358    test $# != 0 &&
359    test "$next" -gt "$last"
360 then
361    rm -fr "$dotest"
362 fi
363
364 if test -d "$dotest"
365 then
366         case "$#,$skip$resolved$abort" in
367         0,*t*)
368                 # Explicit resume command and we do not have file, so
369                 # we are happy.
370                 : ;;
371         0,)
372                 # No file input but without resume parameters; catch
373                 # user error to feed us a patch from standard input
374                 # when there is already $dotest.  This is somewhat
375                 # unreliable -- stdin could be /dev/null for example
376                 # and the caller did not intend to feed us a patch but
377                 # wanted to continue unattended.
378                 test -t 0
379                 ;;
380         *)
381                 false
382                 ;;
383         esac ||
384         die "previous rebase directory $dotest still exists but mbox given."
385         resume=yes
386
387         case "$skip,$abort" in
388         t,t)
389                 die "Please make up your mind. --skip or --abort?"
390                 ;;
391         t,)
392                 git rerere clear
393                 git read-tree --reset -u HEAD HEAD
394                 orig_head=$(cat "$GIT_DIR/ORIG_HEAD")
395                 git reset HEAD
396                 git update-ref ORIG_HEAD $orig_head
397                 ;;
398         ,t)
399                 if test -f "$dotest/rebasing"
400                 then
401                         exec git rebase --abort
402                 fi
403                 git rerere clear
404                 test -f "$dotest/dirtyindex" || {
405                         git read-tree --reset -u HEAD ORIG_HEAD
406                         git reset ORIG_HEAD
407                 }
408                 rm -fr "$dotest"
409                 exit ;;
410         esac
411         rm -f "$dotest/dirtyindex"
412 else
413         # Make sure we are not given --skip, --resolved, nor --abort
414         test "$skip$resolved$abort" = "" ||
415                 die "Resolve operation not in progress, we are not resuming."
416
417         # Start afresh.
418         mkdir -p "$dotest" || exit
419
420         if test -n "$prefix" && test $# != 0
421         then
422                 first=t
423                 for arg
424                 do
425                         test -n "$first" && {
426                                 set x
427                                 first=
428                         }
429                         case "$arg" in
430                         /*)
431                                 set "$@" "$arg" ;;
432                         *)
433                                 set "$@" "$prefix$arg" ;;
434                         esac
435                 done
436                 shift
437         fi
438
439         check_patch_format "$@"
440
441         split_patches "$@"
442
443         # -i can and must be given when resuming; everything
444         # else is kept
445         echo " $git_apply_opt" >"$dotest/apply-opt"
446         echo "$threeway" >"$dotest/threeway"
447         echo "$sign" >"$dotest/sign"
448         echo "$utf8" >"$dotest/utf8"
449         echo "$keep" >"$dotest/keep"
450         echo "$scissors" >"$dotest/scissors"
451         echo "$GIT_QUIET" >"$dotest/quiet"
452         echo 1 >"$dotest/next"
453         if test -n "$rebasing"
454         then
455                 : >"$dotest/rebasing"
456         else
457                 : >"$dotest/applying"
458                 if test -n "$HAS_HEAD"
459                 then
460                         git update-ref ORIG_HEAD HEAD
461                 else
462                         git update-ref -d ORIG_HEAD >/dev/null 2>&1
463                 fi
464         fi
465 fi
466
467 case "$resolved" in
468 '')
469         case "$HAS_HEAD" in
470         '')
471                 files=$(git ls-files) ;;
472         ?*)
473                 files=$(git diff-index --cached --name-only HEAD --) ;;
474         esac || exit
475         if test "$files"
476         then
477                 test -n "$HAS_HEAD" && : >"$dotest/dirtyindex"
478                 die "Dirty index: cannot apply patches (dirty: $files)"
479         fi
480 esac
481
482 if test "$(cat "$dotest/utf8")" = t
483 then
484         utf8=-u
485 else
486         utf8=-n
487 fi
488 if test "$(cat "$dotest/keep")" = t
489 then
490         keep=-k
491 fi
492 case "$(cat "$dotest/scissors")" in
493 t)
494         scissors=--scissors ;;
495 f)
496         scissors=--no-scissors ;;
497 esac
498 if test "$(cat "$dotest/quiet")" = t
499 then
500         GIT_QUIET=t
501 fi
502 if test "$(cat "$dotest/threeway")" = t
503 then
504         threeway=t
505 fi
506 git_apply_opt=$(cat "$dotest/apply-opt")
507 if test "$(cat "$dotest/sign")" = t
508 then
509         SIGNOFF=`git var GIT_COMMITTER_IDENT | sed -e '
510                         s/>.*/>/
511                         s/^/Signed-off-by: /'
512                 `
513 else
514         SIGNOFF=
515 fi
516
517 last=`cat "$dotest/last"`
518 this=`cat "$dotest/next"`
519 if test "$skip" = t
520 then
521         this=`expr "$this" + 1`
522         resume=
523 fi
524
525 if test "$this" -gt "$last"
526 then
527         say Nothing to do.
528         rm -fr "$dotest"
529         exit
530 fi
531
532 while test "$this" -le "$last"
533 do
534         msgnum=`printf "%0${prec}d" $this`
535         next=`expr "$this" + 1`
536         test -f "$dotest/$msgnum" || {
537                 resume=
538                 go_next
539                 continue
540         }
541
542         # If we are not resuming, parse and extract the patch information
543         # into separate files:
544         #  - info records the authorship and title
545         #  - msg is the rest of commit log message
546         #  - patch is the patch body.
547         #
548         # When we are resuming, these files are either already prepared
549         # by the user, or the user can tell us to do so by --resolved flag.
550         case "$resume" in
551         '')
552                 git mailinfo $keep $scissors $utf8 "$dotest/msg" "$dotest/patch" \
553                         <"$dotest/$msgnum" >"$dotest/info" ||
554                         stop_here $this
555
556                 # skip pine's internal folder data
557                 grep '^Author: Mail System Internal Data$' \
558                         <"$dotest"/info >/dev/null &&
559                         go_next && continue
560
561                 test -s "$dotest/patch" || {
562                         echo "Patch is empty.  Was it split wrong?"
563                         stop_here $this
564                 }
565                 if test -f "$dotest/rebasing" &&
566                         commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
567                                 -e q "$dotest/$msgnum") &&
568                         test "$(git cat-file -t "$commit")" = commit
569                 then
570                         git cat-file commit "$commit" |
571                         sed -e '1,/^$/d' >"$dotest/msg-clean"
572                 else
573                         SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
574                         case "$keep_subject" in -k)  SUBJECT="[PATCH] $SUBJECT" ;; esac
575
576                         (printf '%s\n\n' "$SUBJECT"; cat "$dotest/msg") |
577                                 git stripspace > "$dotest/msg-clean"
578                 fi
579                 ;;
580         esac
581
582         GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
583         GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
584         GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
585
586         if test -z "$GIT_AUTHOR_EMAIL"
587         then
588                 echo "Patch does not have a valid e-mail address."
589                 stop_here $this
590         fi
591
592         export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
593
594         case "$resume" in
595         '')
596             if test '' != "$SIGNOFF"
597             then
598                 LAST_SIGNED_OFF_BY=`
599                     sed -ne '/^Signed-off-by: /p' \
600                     "$dotest/msg-clean" |
601                     sed -ne '$p'
602                 `
603                 ADD_SIGNOFF=`
604                     test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
605                     test '' = "$LAST_SIGNED_OFF_BY" && echo
606                     echo "$SIGNOFF"
607                 }`
608             else
609                 ADD_SIGNOFF=
610             fi
611             {
612                 if test -s "$dotest/msg-clean"
613                 then
614                         cat "$dotest/msg-clean"
615                 fi
616                 if test '' != "$ADD_SIGNOFF"
617                 then
618                         echo "$ADD_SIGNOFF"
619                 fi
620             } >"$dotest/final-commit"
621             ;;
622         *)
623                 case "$resolved$interactive" in
624                 tt)
625                         # This is used only for interactive view option.
626                         git diff-index -p --cached HEAD -- >"$dotest/patch"
627                         ;;
628                 esac
629         esac
630
631         resume=
632         if test "$interactive" = t
633         then
634             test -t 0 ||
635             die "cannot be interactive without stdin connected to a terminal."
636             action=again
637             while test "$action" = again
638             do
639                 echo "Commit Body is:"
640                 echo "--------------------------"
641                 cat "$dotest/final-commit"
642                 echo "--------------------------"
643                 printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
644                 read reply
645                 case "$reply" in
646                 [yY]*) action=yes ;;
647                 [aA]*) action=yes interactive= ;;
648                 [nN]*) action=skip ;;
649                 [eE]*) git_editor "$dotest/final-commit"
650                        action=again ;;
651                 [vV]*) action=again
652                        LESS=-S ${PAGER:-less} "$dotest/patch" ;;
653                 *)     action=again ;;
654                 esac
655             done
656         else
657             action=yes
658         fi
659         FIRSTLINE=$(sed 1q "$dotest/final-commit")
660
661         if test $action = skip
662         then
663                 go_next
664                 continue
665         fi
666
667         if test -x "$GIT_DIR"/hooks/applypatch-msg
668         then
669                 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
670                 stop_here $this
671         fi
672
673         say "Applying: $FIRSTLINE"
674
675         case "$resolved" in
676         '')
677                 # When we are allowed to fall back to 3-way later, don't give
678                 # false errors during the initial attempt.
679                 squelch=
680                 if test "$threeway" = t
681                 then
682                         squelch='>/dev/null 2>&1 '
683                 fi
684                 eval "git apply $squelch$git_apply_opt"' --index "$dotest/patch"'
685                 apply_status=$?
686                 ;;
687         t)
688                 # Resolved means the user did all the hard work, and
689                 # we do not have to do any patch application.  Just
690                 # trust what the user has in the index file and the
691                 # working tree.
692                 resolved=
693                 git diff-index --quiet --cached HEAD -- && {
694                         echo "No changes - did you forget to use 'git add'?"
695                         stop_here_user_resolve $this
696                 }
697                 unmerged=$(git ls-files -u)
698                 if test -n "$unmerged"
699                 then
700                         echo "You still have unmerged paths in your index"
701                         echo "did you forget to use 'git add'?"
702                         stop_here_user_resolve $this
703                 fi
704                 apply_status=0
705                 git rerere
706                 ;;
707         esac
708
709         if test $apply_status = 1 && test "$threeway" = t
710         then
711                 if (fall_back_3way)
712                 then
713                     # Applying the patch to an earlier tree and merging the
714                     # result may have produced the same tree as ours.
715                     git diff-index --quiet --cached HEAD -- && {
716                         say No changes -- Patch already applied.
717                         go_next
718                         continue
719                     }
720                     # clear apply_status -- we have successfully merged.
721                     apply_status=0
722                 fi
723         fi
724         if test $apply_status != 0
725         then
726                 printf 'Patch failed at %s %s\n' "$msgnum" "$FIRSTLINE"
727                 stop_here_user_resolve $this
728         fi
729
730         if test -x "$GIT_DIR"/hooks/pre-applypatch
731         then
732                 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
733         fi
734
735         tree=$(git write-tree) &&
736         commit=$(
737                 if test -n "$ignore_date"
738                 then
739                         GIT_AUTHOR_DATE=
740                 fi
741                 parent=$(git rev-parse --verify -q HEAD) ||
742                 say >&2 "applying to an empty history"
743
744                 if test -n "$committer_date_is_author_date"
745                 then
746                         GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
747                         export GIT_COMMITTER_DATE
748                 fi &&
749                 git commit-tree $tree ${parent:+-p} $parent <"$dotest/final-commit"
750         ) &&
751         git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
752         stop_here $this
753
754         if test -x "$GIT_DIR"/hooks/post-applypatch
755         then
756                 "$GIT_DIR"/hooks/post-applypatch
757         fi
758
759         go_next
760 done
761
762 git gc --auto
763
764 rm -fr "$dotest"